# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with site
%if "%{?rhel}" == "6"
%define _jarsign_opts --unsign=%{_javadir}
%bcond_without repolib
%else
%bcond_with repolib
%endif
%bcond_without mead

%define repodir %{_javadir}/repository.jboss.com/org/jboss/slf4j/slf4j-jboss-logging/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define reltag GA
%define namedversion %{version}.%{reltag}

Name:           slf4j-jboss-logging
Version:        1.0.3
Release:        1%{?dist}
Epoch:          0
Summary:        SLF4J to JBoss logging
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn export http://anonsvn.jboss.org/repos/common/slf4j-jboss-logging/tags/1.0.3.GA/ slf4j-jboss-logging-1.0.3
# Exported revision 4856.
# tar cjf slf4j-jboss-logging-1.0.3.tar.bz2 slf4j-jboss-logging-1.0.3
%if %without mead
Source0:        slf4j-jboss-logging-1.0.3.tar.bz2
%endif
Source1:        slf4j-jboss-logging-jpp-depmap.xml
Source2:        slf4j-jboss-logging-settings.xml
Source5:        slf4j-jboss-logging-component-info.xml

Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
Requires:       jboss-common-logging-spi
Requires:       jpackage-utils
Requires:       slf4j
BuildRequires:  jpackage-utils >= 0:1.7.3
%if %with mead
BuildRequires:  %{name}-mead = %{namedversion}
%else
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-release
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  jboss-deploy-maven-plugin
BuildRequires:  jboss-parent
BuildRequires:  jboss-common-logging-spi
BuildRequires:  slf4j
%endif

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
SLF4J to JBoss logging adapter.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%prep
%if %without mead
%setup -q 

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP
%endif

%build
%if %without mead
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        install javadoc:javadoc
%endif

%install
rm -rf %{buildroot}

# jars
install -d -m 755 %{buildroot}%{_javadir}

%if %without mead
install -p -m 644 target/slf4j-jboss-logging-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
%else
install -p -m 644 %{_javadir}/jbossas-fordev/slf4j-jboss-logging-%{namedversion}.jar \
           $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -p -m 644 %{_javadir}/jbossas-fordev/slf4j-jboss-logging-%{namedversion}-sources.jar \
           $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-sources.jar
%endif

(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
%if %without mead
install -p -m 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%else
install -p -m 644 %{_javadir}/jbossas-fordev/slf4j-jboss-logging-%{namedversion}.pom \
           $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%endif
%add_to_maven_depmap org.jboss.slf4j slf4j-jboss-logging %{namedversion} JPP %{name}

# javadoc
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
%if %without mead
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
%else
pushd $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
unzip -q %{_javadir}/jbossas-fordev/slf4j-jboss-logging-%{namedversion}-javadoc.jar
popd
%endif
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
install -d -m 755 %{buildroot}%{repodir}
install -d -m 755 %{buildroot}%{repodirlib}
install -d -m 755 %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE5} %{buildroot}%{repodir}/component-info.xml
tag=`echo %{namedversion}-brew`
sed -i "s/@VERSION@/$tag/g" %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%if %without mead
install -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE1} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE2} %{buildroot}%{repodirsrc}
%else
%{__install} -p -m 644 %{_javadir}/jbossas-fordev/org.jboss.slf4j-slf4j-jboss-logging-%{namedversion}-sources.zip %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{_javadir}/jbossas-fordev/org.jboss.slf4j-slf4j-jboss-logging-%{namedversion}-patches.zip %{buildroot}%{repodirsrc}
%endif
cp -p %{buildroot}%{_javadir}/%{name}-%{version}.jar %{buildroot}%{repodirlib}/slf4j-jboss-logging.jar
cp -p %{buildroot}%{_javadir}/%{name}-%{version}-sources.jar %{buildroot}%{repodirlib}/slf4j-jboss-logging-sources.jar
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom %{buildroot}%{repodirlib}/slf4j-jboss-logging.pom
%if %without mead
%{__install} -p -m 755 %{SOURCE3} %{buildroot}%{repodir}/upload.sh
pushd %{buildroot}%{repodir}
./upload.sh %{buildroot}/usr/share/java/repository.jboss.com/maven2-brew/
popd
%endif
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-%{version}.jar
%{_javadir}*/%{name}-%{version}-sources.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-sources.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Mon Feb 14 2011 Fernando Nasser <fnasser@redhat.com> - 0:1.0.1-1
- Upgrade to 1.0.3.GA
- Add sources JAR to repolib
- Move compilation to MEAD

* Fri Oct 15 2010 David Walluck <dwalluck@redhat.com> 01.0.2-1.5
- rebuild with repolib enabled

* Fri Oct 15 2010 David Walluck <dwalluck@redhat.com> 01.0.2-1.4
- fix maven depmap entry
- fix repolib location in component-info.xml
- fix sed of component-info.xml
- fix repolib copying
- fix repolib option
- fix repolib file permissions
- fix repolib file ownership

* Fri May 07 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.2-1.3.1
- rebuilt

* Tue Apr 06 2010 Hui Wang <huwang@redhat.com> - 0:1.0.2-1.3
- Rebuild

* Wed Nov 11 2009 Yong Yang <yyang@redhat.com> - 0:1.0.2-1.2
- Add repolib

* Wed Aug 19 2009 David Walluck <dwalluck@redhat.com> 0:1.0.2-1.1
- BuildRequires: jboss-parent 

* Wed Jun 24 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.0.2-1.jpp5
- first release
